package mod;

/**
 * Class to represent a node in the dendogram.
 * Part of the implementation for solving the QP for modularity maximization problem
 * @author Gaurav Agarwal
 *
 */
public class Node
{
    private int m_id;
    private int[] m_points;
    private Node m_left;
    private Node m_right;
    double m_delta;


    public int getId()
    {
        return m_id;
    }

    public Node getLeft()
    {
        return m_left;
    }

    public Node getRight()
    {
        return m_right;
    }

    public double getDelta()
    {
        return m_delta;
    }

    public void setDelta(double delta)
    {
        m_delta = delta;
    }


    public void setRight(Node right)
    {
        m_right = right;
    }

    public void setLeft(Node left)
    {
        m_left = left;
    }


    public int[] getPoints()
    {
        return m_points;
    }

    public boolean equals(Object o)
    {
        Node ob1 = (Node) o;
        if (ob1.getId() == m_id)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    public Node(int[] points, int id)
    {
        int partitionLength = points.length;
        m_points = new int[partitionLength];
        for (int i = 0; i < partitionLength; i++)
        {
            m_points[i] = points[i];
        }
        m_id=id;
    }
}