% Method to iteratively split the input into smaller clusters.
% The propsed flow
% Split the main group in two
% Calculate the delta
% Put it in the DendoGram
% While Dendogram has more elemnts to split
%   Get the clusters as a result of most favorable split
%   For each child
%       Get the induced adjacency matrix
%       Split the child cluster in two
%       Label the obtained clusters with the ids from the original group
%       Put the obtained children back in dendogram with its id as parent
%       ID

%ENDWHILE


%INPUT  : <Adjaceny Matrix> , <Cluster OutPut file name>
%OUTPUT : An array of clusters

function CLUSTER_ARRAY=progressive_sdp_cluster(orig_adj_mat,op_file)

n=length(orig_adj_mat);
[m,K]=calculate_edge_count(orig_adj_mat);
ORIG_GROUP=[1:n];
dendogram=mod.DendoGram;
    
[delta,new_clusters]=sdp_cluster(orig_adj_mat,m,K,ORIG_GROUP);

dendogram.addRoot(ORIG_GROUP,new_clusters{1},new_clusters{2},delta);

while(dendogram.elemtntsLeftForSplitting()>0)
    children=dendogram.splitForMaxDelta();
    if(length(children(1))==1 && length(children(2))==1)
        for childId=1:2
            child=children(childId);
            childPoints=child.getPoints();
            childpointsLength=length(childPoints);

            if(childpointsLength > 1)

                %adj_mat=redistribute(childPoints,orig_adj_mat);
                %[delta,new_clusters]=sdp_cluster(adj_mat,m,K,childPoints);
                [delta,new_clusters]=sdp_cluster(orig_adj_mat,m,K,childPoints);
                % Add the clusters to the Dendogram
                dendogram.addPartition(child.getId(),new_clusters{1},new_clusters{2},delta);

            end
        end
    end
end
dendogram.dumpcluster2File(op_file);